#ifndef JOY_STICK_H
#define JOY_STICK_H

#include <vector>

class JoystickInfo;

class Joystick
{
friend class JoystickInfo;
protected:
	int id;
	int maxDir [ 6 ], minDir [ 6 ];
	int buttons;

	Joystick ( int id, int maxDir [ 6 ], int minDir [ 6 ], int buttons );

public:
	// constructs an invalid joystick
	Joystick ( void );

	// returns the number of buttons on this joystick
	int numButtons ( void ) const;

	// buttons is bit array with 1 set if button currently pressed
	// pos is array of positions between [-1,1] in pairs (0,1), (2,3), (4,5)
	// pov is angle in degrees between 0 and 359 or -1 if not pressed
	bool getState ( int &buttons, float pos [ 6 ], float &pov ) const;
};

class JoystickInfo
{
public:
	// returns number of joysticks connected and fills sticks with the joystick info
	static int getJoySticks ( std::vector<Joystick> &sticks );
};

#endif